<?php
/*
 * Text.class.php - Vips plugin for Stud.IP
 * Copyright (c) 2006  Martin Schrder
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 */

class Text extends Component
{
        // type of the component, used for output
        var $g_component_type;

        // title of a component instance, used for output
        var $g_component_title;

        // component's position in the exercise (beginning with 1!)
        var $g_component_position;

        // text content
        var $g_content;

        // constructor
        function Text()
        {
                $this->g_component_type = _("Text");
                $this->g_component_title = _("Aufgabentext");
                $this->g_component_position = 0;
        }





        // initialises the global variables using the DOM data representing this component
        function init_component($p_dom)
        {
                $this->g_component_title = $p_dom->get_attribute("title");
                $this->g_component_position = $p_dom->get_attribute("position");
                $text_node = $p_dom->first_child();
                $this->g_content = $text_node->node_value();
        }





        // generates the lecturer's view of the component (i.e. for generating and adjusting)
        function generate_component_edit()
        {
                global $vipsTemplateFactory;

                $tmpl = $vipsTemplateFactory->open('exercises/edit_text_component');

#               $tmpl->set_attribute("t_exercise_type", vips_get_string_param("exercise_type"));
#               $tmpl->set_attribute("t_exercise_id", vips_get_int_param("exercise_id"));
#               $tmpl->set_attribute("t_assignment_id", vips_get_int_param("assignment_id"));
#               $tmpl->set_attribute("t_action", vips_get_string_param("action"));
#               $tmpl->set_attribute("t_unfold", vips_get_int_param("unfold"));

                $tmpl->set_attribute("t_component_type", $this->g_component_type);
                $tmpl->set_attribute("t_component_title", $this->g_component_title);
                $tmpl->set_attribute("t_component_position", $this->g_component_position);
                $tmpl->set_attribute("t_content", $this->g_content);

                return $tmpl->render();
        }





        // generates the student's view of the component (i.e. for solving)
        function generate_component_show()
        {
                global $vipsTemplateFactory;

                $tmpl = $vipsTemplateFactory->open('exercises/show_edit_text_component');

                $tmpl->set_attribute("t_content");

                return $tmpl->render();
        }





        // generates XML representing the component
        function generate_XML() {}

}

?>
