<?php
/*
 * zu_exercise.php - Vips plugin for Stud.IP
 * Copyright (c) 2003-2005  Erik Schmitt, Philipp Hgelmeyer
 * Copyright (c) 2005-2006  Christa Deiwiks
 * Copyright (c) 2006-2007  Elmar Ludwig, Martin Schrder
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 */

require_once 'exercises/exercise.php';

/**
 * XXX detailed description
 *
 * @author    XXX
 * @copyright XXX
 * @abstract
 */
class zu_exercise extends Exercise {

    function zu_exercise() {

    }



    /**
     *    Evaluates a solution.
     *
     *    @abstract
     *    @access public
     *    @returns int (from 0 to 100 ) as an % value
     */

    function evaluate($exercise, $solution)
    {

    }



    /**
     *    This function gens a Solution, that is stored to the database.
     *    solution_id.
     *
     *    @access public
     *    @returns XML contains the solution coded in an XML-string
     */

    function genSolution($exercise_id, $p_number_of_answers = null) {

    }



    /**
     *    Generate the XML-input for the database for an exercise.
     *
     *    @abstract
     *    @access public
     *    @returns bool
     */

    function getExerciseConstruct() {

        /**********************************************************************/
        /* Get data
        /*
        /* exercise_type = name of this class
        /**********************************************************************/

        $m_exercise_language = "de";
        $m_exercise_type     = vips_get_string_param("exercise_type");
        $m_exercise_question = vips_get_string_param("exercise_question", true);
        $m_exercise_name         = vips_get_string_param("exercise_name", true);
        $m_exercise_hint     = vips_get_string_param("exercise_hint", true);
        $m_exercise_comment  = vips_get_int_param("exercise_comment");

        $m_exercise_picurl       = basename($_FILES['exercise_picurl']['name']);        //after upload
        if (!$m_exercise_picurl)
            $m_exercise_picurl  = urlencode(vips_get_string_param("exercise_picurl"));

        $m_provides          = vips_get_string_param("provides");
        $m_depends           = vips_get_string_param("depends");
        $m_optional_depends  = vips_get_string_param("optional_depends");

        $m_answer_default        = vips_get_string_param("answer_default", true);

        $m_number_of_answers = vips_get_int_param("number_of_answers");

        $counter             = 1;

        /**********************************************************************/
        /* Construct XML
        /**********************************************************************/

        $xmlop  = "<TestItem ID=\"" . $m_exercise_type . "\" Type=\"".$this->g_ExerciseName."\" Language=\"" . $m_exercise_language . "\">";
        $xmlop .= "<Name>".htmlspecialchars($m_exercise_name)."</Name>";
        $xmlop .= "<Hint>".htmlspecialchars($m_exercise_hint)."</Hint>";
        $xmlop .= "<CommentField Visible=\"".$m_exercise_comment."\"></CommentField>";
        $xmlop .= "<PictureURL>".htmlspecialchars($m_exercise_picurl)."</PictureURL>";
        $xmlop .= "<Provides>".htmlspecialchars($m_provides)."</Provides>";
        $xmlop .= "<Depends>".htmlspecialchars($m_depends)."</Depends>";
        $xmlop .= "<OptionalDepends>".htmlspecialchars($m_optional_depends)."</OptionalDepends>";
        $xmlop .= "<AnswerDefault>".htmlspecialchars($m_answer_default)."</AnswerDefault>";
        $xmlop .= "<Question>";
        $xmlop .= "<Paragraph>".htmlspecialchars($m_exercise_question)."</Paragraph>";
        $xmlop .= "</Question>";

        for ($i = 0; $i < $m_number_of_answers; $i++) {
            $text = html_ready(vips_get_string_param("answer_$i", true));
            if ($text) {
                $x1  = vips_get_int_param("answer_$i-0");
                $y1  = vips_get_int_param("answer_$i-1");
                $x2  = vips_get_int_param("answer_$i-2");
                $y2  = vips_get_int_param("answer_$i-3");
                $xmlop .= "<Answer x1=\"$x1\" y1=\"$y1\" x2=\"$x2\" y2=\"$y2\">".htmlspecialchars($text)."</Answer>";
            }
        }
        /**********************************************************************/
        /* Return XML
        /**********************************************************************/
        $xmlop .= "</TestItem>";
        return vips_filter_xml_string($xmlop);
    }



}  // end class
?>
